package test;

import java.util.Hashtable;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;


public class TestHornetQSpin extends Thread
{
	private InitialContext m_context = null;
	
	private ConnectionFactory getConnectionFactory() throws Exception {
		InitialContext context = getContext();
		ConnectionFactory factory = (ConnectionFactory) context.lookup( "ConnectionFactory");
		return( factory );
	}
	
	private InitialContext getContext() throws Exception {
		if( m_context == null )	{
			Hashtable<String, String> environment = new Hashtable<String, String>();
			environment.put( Context.PROVIDER_URL, "remoteserver:1099");
			environment.put( Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
			m_context = new InitialContext( environment );
		}
		return( m_context );
	}
	
	public void run() {
		ConnectionFactory factory =null;
		Connection connection = null;	
		Session session = null;	
		MessageProducer producer = null;
		MessageConsumer consumer = null;
		try {
			factory = getConnectionFactory();
			connection = factory.createConnection();
			session = connection.createSession( false, Session.AUTO_ACKNOWLEDGE );
			connection.start();
			TextMessage message = session.createTextMessage();
			message.setText( "TestMessage");
			Queue dQueue = getQueue( "/queue/Test");
			producer = session.createProducer(dQueue);
			producer.send( dQueue, message );
			producer.close();
			consumer = session.createConsumer( dQueue, "JMSCorrelationID = '7688744c-127247625ff--7f38f6db7'");
			consumer.receive( 120000 );

		}
		catch( Exception ex ) {
			ex.printStackTrace();
		}finally {
			try	{
				if( consumer != null ) {
					consumer.close();
				}
				
				if( session != null ) {
					session.close();
				}
				
				if( connection != null ) {
					connection.stop();
					connection.close();
				}
			} catch( Exception ex ) {
				ex.printStackTrace();
			}
		}
	}
	
	public Queue getQueue( String name ) throws Exception  {
		InitialContext context = getContext();
		Queue retQueue = (Queue) context.lookup(name);
		return( retQueue );
	}
	
	public static void main( String[] args ) {
		try	{
			new TestHornetQSpin().start();
			new TestHornetQSpin().start();
			new TestHornetQSpin().start();
			new TestHornetQSpin().start();
			new TestHornetQSpin().start();
			new TestHornetQSpin().start();
		} catch( Exception ex ) {
			ex.printStackTrace();
		}
	}
}
